' ----------------------------------------------
' FormedLead.vbs
' Apr 1, 2013 Started by Tyler Reid
' Rev 1 Released by Tyler Reid 4/8/13
' Known Bugs: 
' Can't have angle of 0 degrees(no step), not the intention of this program, not worth implementing
' Can't run multiple times. Naming conflicts.
' No parameterization for live manipulation.
' ----------------------------------------------
Dim oAnsoftApp
Dim oDesktop
Dim oProject
Dim oDesign
Dim oEditor
Dim oModule
Dim strOffsetY, strOffsetX, strLength1, strLength2, strLength3, strMinRadius, strLeadThickness, strUnits, strStepHeight, strAngle, strLeadWidth
Dim blnIsLength1, blnIsLength2, blnIsMinRadius, blnIsLeadThickness, blnIsStepHeight, blnIsAngle, blnIsLeadWidth
Dim strXStart, strYStart, strZStart
Dim i, j, k
Dim local_var_array
Dim position
Dim coord

Set oAnsoftApp = CreateObject("AnsoftHfss.HfssScriptInterface")
Set oDesktop = oAnsoftApp.GetAppDesktop()
oDesktop.RestoreWindow
Set oProject = oDesktop.GetActiveProject()
Set oDesign = oProject.GetActiveDesign()
Set oEditor = oDesign.SetActiveEditor("3D Modeler")

'check for variables
local_var_array = oDesign.GetVariables()

'Get start point for lead
position  = oEditor.GetUserPosition("Select point for start of lead.")
strXStart = position(0)
strYStart = position(1)
strZStart = position(2)
'Gather information from user/Populate variables

strUnits = inputBox("enter the units of length:", Units,"mil")
if(strUnits = "mils") then strUnits = "mil"
strUnits = getUnits(strUnits)
do while strComp(strUnits,"") = 0
	strUnits = inputBox("Not a valid unit, please enter units:", Units, "mil") 
loop

for each variable in local_var_array
	select case variable
	  case "strLength1" 
		blnIsLength1 = true
	  case "strLength2" 
		blnIsLength2 = true
	  case "strLeadWidth" 
		blnIsLeadWidth = true
	  case "strLeadThickness" 
		blnIsLeadThickness = true
	  case "strStepHeight" 
		blnIsStepHeight = true  
	  case "strAngle" 
		blnIsAngle = true
	  case "strMinRadius" 
		blnIsMinRadius = true
	 
	end select
next  

 if blnIsLength1 = true then 
	strLength1 = RemoveUnits(oDesign.GetVariableValue("strLength1"))
 else 
	strLength1 = inputBox("Enter length of lead from start point to bend:", "Length1", "20")
	oDesign.ChangeProperty Array("NAME:AllTabs", Array("NAME:LocalVariableTab", Array("NAME:PropServers",  _
	  "LocalVariables"), Array("NAME:NewProps", Array("NAME:strLength1", "PropType:=",  _
	  "VariableProp", "UserDef:=", true, "Value:=", strLength1 & strUnits))))
 end if
 if  blnIsLength2 = true then 
	strLength2 = RemoveUnits(oDesign.GetVariableValue("strLength2"))
 else strLength2 = inputBox("Enter length of lead from lower bend to end", "Length2", "20")
	oDesign.ChangeProperty Array("NAME:AllTabs", Array("NAME:LocalVariableTab", Array("NAME:PropServers",  _
	  "LocalVariables"), Array("NAME:NewProps", Array("NAME:strLength2", "PropType:=",  _
	  "VariableProp", "UserDef:=", true, "Value:=", strLength2 & strUnits))))
 end if
 if blnIsLeadWidth = true then 
	strLeadWidth = RemoveUnits(oDesign.GetVariableValue("strLeadWidth"))
 else strLeadWidth = inputBox("Enter lead width:", "Lead Width", "12") 
	oDesign.ChangeProperty Array("NAME:AllTabs", Array("NAME:LocalVariableTab", Array("NAME:PropServers",  _
	  "LocalVariables"), Array("NAME:NewProps", Array("NAME:strLeadWidth", "PropType:=",  _
	  "VariableProp", "UserDef:=", true, "Value:=", strLeadWidth & strUnits))))
 end if
 if blnIsLeadThickness = true then 
	strLeadThickness = RemoveUnits(oDesign.GetVariableValue("strLeadThickness"))
 else strLeadThickness = inputBox("Enter Lead Thickness:", "Lead Thickness", "5")
	oDesign.ChangeProperty Array("NAME:AllTabs", Array("NAME:LocalVariableTab", Array("NAME:PropServers",  _
	  "LocalVariables"), Array("NAME:NewProps", Array("NAME:strLeadThickness", "PropType:=",  _
	  "VariableProp", "UserDef:=", true, "Value:=", strLeadThickness & strUnits))))
 end if
 if blnIsStepHeight = true then 
	strStepHeight = RemoveUnits(oDesign.GetVariableValue("strStepHeight"))
 else strStepHeight = inputBox("Enter step height:", "Step Height", "36")
	oDesign.ChangeProperty Array("NAME:AllTabs", Array("NAME:LocalVariableTab", Array("NAME:PropServers",  _
	  "LocalVariables"), Array("NAME:NewProps", Array("NAME:strStepHeight", "PropType:=",  _
	  "VariableProp", "UserDef:=", true, "Value:=", strStepHeight & strUnits))))
 end if
 if blnIsAngle = true then 
	strAngle = RemoveUnits(oDesign.GetVariableValue("strAngle"))
 else strAngle = inputBox("Enter angle in degrees:", "Angle", "45")
	oDesign.ChangeProperty Array("NAME:AllTabs", Array("NAME:LocalVariableTab", Array("NAME:PropServers",  _
	  "LocalVariables"), Array("NAME:NewProps", Array("NAME:strAngle", "PropType:=",  _
	  "VariableProp", "UserDef:=", true, "Value:=", strAngle))))
 end if
 if blnIsMinRadius = true then 
 else strMinRadius = inputBox("Enter minimum bend radius:", "Min Radius", "5")
	oDesign.ChangeProperty Array("NAME:AllTabs", Array("NAME:LocalVariableTab", Array("NAME:PropServers",  _
	  "LocalVariables"), Array("NAME:NewProps", Array("NAME:strMinRadius", "PropType:=",  _
	  "VariableProp", "UserDef:=", true, "Value:=", strMinRadius & strUnits))))
 end if
'Create Lead
oEditor.CreateRelativeCS Array("NAME:RelativeCSParameters", "OriginX:=", strXStart ,"OriginY:=", strYStart , _
"OriginZ:=", strZStart ,"XAxisXvec:=", "1mil","XAxisXVec:=","0mil","XAxisZVec:=","0mil", _
"YAxisXvec:=","0mil" ,"YAxisYvec:=","1mil", "YAxisZvec:=", "0mil"), Array("Name:Attributes", "Name:=", "LeadRelativeCS1")

oEditor.SetWCS Array("NAME:SetWCS Parameter","Working Coordinate System:=","LeadRelativeCS1")
'Create first length
oEditor.CreateBox Array("NAME:BoxParameters", "XPosition:=", "0mils", "YPosition:=",  _
  "0mils", "ZPosition:=", "0mils", "XSize:=", strLength1 & strUnits, "YSize:=", strLeadWidth & strUnits, "ZSize:=",  _
  strLeadThickness & strUnits), Array("NAME:Attributes", "Name:=", "LeadBox1", "Flags:=", "", "Color:=",  _
  "(255 255 128)", "Transparency:=", 0, "PartCoordinateSystem:=", "Global", "UDMId:=",  _
  "", "MaterialValue:=", "" & Chr(34) & "pec" & Chr(34) & "", "SolveInside:=", false)

'create second length
oEditor.CreateRelativeCS Array("NAME:RelativeCSParameters", "OriginX:=", strLength1 & strUnits ,"OriginY:=", "0mils", _
  "OriginZ:=", CStr(-CDbl(strMinRadius)) & strUnits ,"XAxisXvec:=", "1mil","XAxisXVec:=", "0mil","XAxisZVec:=", "0mil", _
  "YAxisXvec:=", "0mil" ,"YAxisYvec:=", "1mil", "YAxisZvec:=", "0mil"), Array("NAME:Attributes", "Name:=", "LeadRelativeCS2")

'Create first bend
oEditor.SetWCS Array("NAME:SetWCS Parameter","Working Coordinate System:=","LeadRelativeCS2")
'leadObject = CreateSweptRectangle(strLeadWidth & strUnits, strLeadThickness & strUnits, strMinRadius & strUnits, strAngle)
oEditor.CreateRectangle Array("NAME:RectangleParameters", "XStart:=", "0mils", "YStart:=", "0mils", "ZStart:=", _
	strMinRadius & strUnits, "Width:=", strLeadWidth & strUnits,"Height:=", strLeadThickness & strUnits, "WhichAxis:=", "X"), _
	Array("NAME:Attributes", "Name:=", "ArchRect1")
	
oEditor.SweepAroundAxis Array("NAME:Selections", "Selections:=", "ArchRect1"), Array("NAME:AxisSweepParameters", _
	"DraftAngle:=", "0", "DraftType:=", "Natural", "SweepAxis:=", "Y", "SweepAngle:=", strAngle & "deg")

'Create angled length
	'create / set WCS
oEditor.CreateRelativeCS Array("NAME:RelativeCSParameters", "OriginX:=", Sin(deg2rad(strAngle)) * strMinRadius & _
  strUnits, "OriginY:=", "0mils", "OriginZ:=", CStr(Cos(deg2rad(strAngle)) * CDbl(strMinRadius)) & strUnits , _
  "XAxisXvec:=", Cos(deg2rad(strAngle)) & strUnits,"XAxisXVec:=", "0","XAxisZVec:=", -Sin(deg2rad(strAngle)) & strUnits, _
  "YAxisXvec:=", "0mil", "YAxisYvec:=", "1mil", "YAxisZvec:=", "0mil"), Array("NAME:Attributes", "Name:=", "LeadRelativeCS3")

oEditor.SetWCS Array("NAME:SetWCS Parameter","Working Coordinate System:=","LeadRelativeCS3")

strLength3 = (cdbl(strStepHeight) - (2 * cdbl(strMinRadius)) + cdbl(strMinRadius) * Cos(deg2rad(strAngle)) - cdbl(strLeadThickness) _
+(cdbl(strMinRadius) + cdbl(strLeadThickness)) * Cos(deg2rad(strAngle)))/Sin(deg2rad(strAngle))
' for debug msgbox("length3" & strLength3)
oEditor.CreateBox Array("NAME:BoxParameters", "XPosition:=", "0mils", "YPosition:=",  _
  "0mils", "ZPosition:=", "0mils", "XSize:=", strLength3 & strUnits, "YSize:=", strLeadWidth & strUnits, "ZSize:=",  _
  strLeadThickness & strUnits), Array("NAME:Attributes", "Name:=", "LeadBox3", "Flags:=", "", "Color:=",  _
  "(255 255 128)", "Transparency:=", 0, "PartCoordinateSystem:=", "Global", "UDMId:=",  _
  "", "MaterialValue:=", "" & Chr(34) & "pec" & Chr(34) & "", "SolveInside:=", false)
' for debug msgBox(oEditor.GetNumObjects)

'create second bend
oEditor.CreateRelativeCS Array("NAME:RelativeCSParameters", "OriginX:=", strLength3 & strUnits, "OriginY:=", "0mils", _
 "OriginZ:=", (CDbl(strLeadThickness) + CDbl(strMinRadius)) & strUnits, "XAxisXvec:=", _ 
 Cos(deg2rad(strAngle)) & strUnits,"XAxisXVec:=", "0","XAxisZVec:=", Sin(deg2rad(strAngle)) & strUnits, _
 "YAxisXVec:=", "0mil", "YAxisYVec:=", "1mil", "YAxisZVec:=", "0mil"), Array("NAME:Attributes", "Name:=", "LeadRelativeCS4")

oEditor.SetWCS Array("NAME:SetWCS Parameter", "Working Coordinate System:=", "LeadRelativeCS4")
'leadObject = CreateSweptRectangle(strLeadWidth & strUnits, strLeadThickness & strUnits, strMinRadius & strUnits, strAngle)
oEditor.CreateRectangle Array("NAME:RectangleParameters", "XStart:=", "0mils", "YStart:=", "0mils", "ZStart:=", _
	-strMinRadius & strUnits, "Width:=", strLeadWidth & strUnits,"Height:=", -strLeadThickness & strUnits, "WhichAxis:=", "X"), _ 
	Array("NAME:Attributes", "Name:=", "ArchRect2")
	
oEditor.SweepAroundAxis Array("NAME:Selections", "Selections:=", "ArchRect2"), Array("NAME:AxisSweepParameters", _
	"DraftAngle:=", "0", "DraftType:=", "Natural", "SweepAxis:=", "Y", "SweepAngle:=", strAngle & "deg")

'msgBox(oEditor.getObjectName(0) & oEditor.getObjectName(1)& oEditor.getObjectName(2) & oEditor.getObjectName(3))
'oEditor.Rotate Array("NAME:Selections", objectName), Array("NAME:RotateParameters", "RotateAxis:=", "Y","RotateAngle:=", "180deg")
'leadObject(2) = CreateSweptRectangle(strLeadWidth & strUnits, -strLeadThickness & strUnits, -strMinRadius & strUnits, strAngle) 

'Create third length
oEditor.CreateBox Array("NAME:BoxParameters", "XPosition:=", "0mils", "YPosition:=",  _
  "0mils", "ZPosition:=", -strMinRadius & strUnits, "XSize:=", strLength2 & strUnits, "YSize:=", strLeadWidth & strUnits, "ZSize:=",  _
  -strLeadThickness & strUnits), Array("NAME:Attributes", "Name:=", "LeadBox2", "Flags:=", "", "Color:=",  _
  "(255 255 128)", "Transparency:=", 0, "PartCoordinateSystem:=", "Global", "UDMId:=",  _
  "", "MaterialValue:=", "" & Chr(34) & "pec" & Chr(34) & "", "SolveInside:=", false)
'unite segments
'assign materials/color

oEditor.SetWCS Array("NAME:SetWCS Parameter","Working Coordinate System:=","LeadRelativeCS1")

'Fails when used more than once.
Function CreateSweptRectangle(rectWidth, rectHeight, innerRadius, sweepAngleDeg)
	
	oEditor.CreateRectangle Array("NAME:RectangleParameters", "XStart:=", "0mils", "YStart:=", "0mils", "ZStart:=", _
	innerRadius, "Width:=", rectWidth,"Height:=", rectHeight, "WhichAxis:=", "X"), Array("NAME:Attributes", "Name:=", "ArchRect")
	
	oEditor.SweepAroundAxis Array("NAME:Selections", "Selections:=", "ArchRect"), Array("NAME:AxisSweepParameters", _
	"DraftAngle:=", "0", "DraftType:=", "Natural", "SweepAxis:=", "Y", "SweepAngle:=", sweepAngleDeg & "deg")
	CreateSweptRectangle = ArchRect
end function  

'Returns the units as a string, INCOMPLETE LIST needs voltage, speed, torque, induction, pressure,
' Conductance, weight, inductance, capacitance, Force, Angular speed, Mag field Strength
'It is recommended to remove the irrelevant units for your use to speed up execution 
Function getUnits(strWithUnits)
	if InStr(strWithUnits, "cm") then
		getUnits = "cm"
		elseIf InStr(strWithUnits, "BTU_per_hr") then getUnits = "BTU_per_hr"
		elseIf InStr(strWithUnits, "cel") then getUnits = "cel"
		elseIf InStr(strWithUnits, "ckel") then getUnits = "ckel"
		elseIf InStr(strWithUnits, "day") then getUnits = "day"
		elseIf InStr(strWithUnits, "dBm") then getUnits = "dBm"
		elseIf InStr(strWithUnits, "dBW") then getUnits = "dBW"
		elseIf InStr(strWithUnits, "degsec") then getUnits = "degsec"
		elseIf InStr(strWithUnits, "degmin") then getUnits = "degmin"
		elseIf InStr(strWithUnits, "deg") then getUnits = "deg"
		elseIf InStr(strWithUnits, "dkel") then getUnits = "dkel"
		elseIf InStr(strWithUnits, "dm") then getUnits = "dm"
		elseIf InStr(strWithUnits, "fah") then getUnits = "fah"
		elseIf InStr(strWithUnits, "fA") then getUnits = "fA"
		elseIf InStr(strWithUnits, "fm") then getUnits = "fm"
		elseIf InStr(strWithUnits, "fs") then getUnits = "fs"
		elseIf InStr(strWithUnits, "ft") then getUnits = "ft"	
		elseIf InStr(strWithUnits, "fW") then getUnits = "fW"
		elseIf InStr(strWithUnits, "GHz") then getUnits = "GHz"
		elseIf InStr(strWithUnits, "GOhm") then getUnits = "GOhm"
		elseIf InStr(strWithUnits, "gW") then getUnits = "gW"
		elseIf InStr(strWithUnits, "HP") then getUnits = "HP"
		elseIf InStr(strWithUnits, "hr") then getUnits = "hr"
		elseIf InStr(strWithUnits, "in") then getUnits = "in"
		elseIf InStr(strWithUnits, "kA") then getUnits = "kA"
		elseIf InStr(strWithUnits, "kel") then getUnits = "kel"
		elseIf InStr(strWithUnits, "kHz") then getUnits = "kHz"
		elseIf InStr(strWithUnits, "km") then getUnits = "km"
		elseIf InStr(strWithUnits, "kOhm") then getUnits = "kOhm"
		elseIf InStr(strWithUnits, "kW") then getUnits = "kW"
		elseIf InStr(strWithUnits, "lightyear") then getUnits = "lightyear"
		elseIf InStr(strWithUnits, "mA") then getUnits = "mA"
		elseIf InStr(strWithUnits, "mOhm") then getUnits = "mOhm"
		elseIf InStr(strWithUnits, "megW") then getUnits = "megW"
		elseIf InStr(strWithUnits, "megOhm") then getUnits = "megOhm"
		elseIf InStr(strWithUnits, "meter") then getUnits = "meter"
		elseIf InStr(strWithUnits, "MHz") then getUnits = "MHz"
		elseIf InStr(strWithUnits, "mileNaut") then getUnits = "mileNaut"
		elseIf InStr(strWithUnits, "mileTerr") then getUnits = "mileTerr"		
		elseIf InStr(strWithUnits, "mile") then getUnits = "mile"
		elseIf InStr(strWithUnits, "mil") then getUnits = "mil"
		elseIf InStr(strWithUnits, "min") then getUnits = "min"
		elseIf InStr(strWithUnits, "mkel") then getUnits = "mkel"
		elseIf InStr(strWithUnits, "mm") then getUnits = "mm"
		elseIf InStr(strWithUnits, "nA") then getUnits = "nA"
		elseIf InStr(strWithUnits, "ms") then getUnits = "ms"
		elseIf InStr(strWithUnits, "nm") then getUnits = "nm"
		elseIf InStr(strWithUnits, "ns") then getUnits = "ns"
		elseIf InStr(strWithUnits, "nW") then getUnits = "nW"
		elseIf InStr(strWithUnits, "pm") then getUnits = "pm"
		elseIf InStr(strWithUnits, "per_sec") then getUnits = "per_sec"
		elseIf InStr(strWithUnits, "ps") then getUnits = "ps"
		elseIf InStr(strWithUnits, "pW") then getUnits = "pW"
		elseIf InStr(strWithUnits, "rad") then getUnits = "rad"
		elseIf InStr(strWithUnits, "rps") then getUnits = "rps"
		elseIf InStr(strWithUnits, "thz") then getUnits = "thz"
		elseIf InStr(strWithUnits, "uA") then getUnits = "uA"
		elseIf InStr(strWithUnits, "uin") then getUnits = "uin"
		elseIf InStr(strWithUnits, "um") then getUnits = "um"
		elseIf InStr(strWithUnits, "uOhm") then getUnits = "uOhm"
		elseIf InStr(strWithUnits, "us") then getUnits = "us"
		elseIf InStr(strWithUnits, "uW") then getUnits = "uW"
		elseIf InStr(strWithUnits, "W") then getUnits = "W"
		elseIf InStr(strWithUnits, "yd") then getUnits = "yd"
		elseIf InStr(strWithUnits, "ohm") then getUnits = "ohm"
		elseIf InStr(strWithUnits, "Hz") then getUnits = "Hz"
		elseIf InStr(strWithUnits, "s") then getUnits = "s"
		elseIf InStr(strWithUnits, "A") then getUnits = "A"
		elseif InStr(strWithUnits, "m") then getUnits = "meter"
		Else 
			msgBox (strWithUnits & "No valid unit of length found in: " & strWithUnits)
			getUnits = ""
	end if
end Function

'this function returns a string with the units removed
Function RemoveUnits(strWithUnits)
	dim units, lengthOfString
	units = getUnits(strWithUnits)
	RemoveUnits = left(strWithUnits,len(strWithUnits)-len(units))
end Function	

'  This function converts decimal degrees to radians
'  
Function deg2rad(Deg)
	pi = 4 * Atn(1)
	deg2rad = cdbl(Deg * pi / 180)
End Function

'  This function converts radians to decimal degrees
'  
Function rad2deg(Rad)
	pi = 4 * Atn(1)
	rad2deg = cdbl(Rad * 180 / pi)
End Function

